QGIS Application - Feature request #10454
New and improved save/export dialog
2014-06-04 04:03 AM - Nathan Woodrow

Status: Open

Priority: Normal

Assignee: Nathan Woodrow

Category: GUI

Pull Request or Patch supplied: Resolution:

Easy fix?: No Copied to github as #: 18866
Description

This is a mockup of a new Ul | am thinking of for exporting layers, single or multi. Opening a ticket here for more feedback and so | don't
forgot the idea like | normally do ;)
Currently the main issues | have with current Save/Export method are:
1. Model - and we all know how much | hate those kinds of dialogs
2. One layer at a time
3. Only exports to ogr based layers
4. Ul just doesn't feel right - advanced options feel disjoined
Other issue | have, which are related to 3), are:
1. One method for saving disk based formats - Save As dialog
2. Drag and Drop for browser, only supports some providers, not file based formats - can't drag loaded layers
3. DB Manager is good but not for everything, and is more steps then | would like - doesn't support file based formats (excluding: sqlite)
4. There is not one way to export data to any format

QGIS has strong data format support and import and exporting should be a lot cleaner.

So here is the mock up idea.
New tab (can close) in the main area, with Map in the other (you will see why later)

- The top of the widget is a layer list, with checkable items (the shortcut to tick is the current right click save As.. which opens the tab)

- The options are on the right of the list (not all shown in mockup), advanced options would expand under the top row above the line.

- Below the line is a new concept of targets/favorites, these are pre configured export settings. Layers can be drop onto a target to
export using those settings, it would just be a drop and leave type thing. Some settings have a "ask" option so it will ask you when you
drop something onto it, maybe location, or projection. Martin and | have talked about the idea of reusing browser favorites and just adding
extra export metadata. This would be good as it means favorites are export targets, and targets are favorites. Layers could be dropped

from Layer List, Browser, OS File Explorer, etc.
- Many layers can be exported at once
- Layers will be queued for export and are threaded so it's non blocking
- Non model
- Export to any supported provider in QGIS in one place.

- We have a lot more room to work with using a tab. There is no need to have a dialog when you can just flick back to the map to view

it, and | hate having to micro manage floating dialogs all the time.

History

#1 - 2014-06-04 04:07 AM - Giovanni Manghi

very nice ideal

#2 - 2014-06-04 04:33 AM - Werner Macho

2025-04-26

2/5




Very nice idea

The most annoying thing for me is that you cannot "save as" a layer within an already existing spatialite database .. Probably this will address that issue as

well.

And probably take a look at alexander bruys QConsolidate plugin as well :)

#3 - 2014-06-04 04:53 AM - Richard Duivenvoorde

I think it is a good plan to streamline the 'saveas' functions more to work for other data types.
But isn't this the beginning of ETL tool like FME? With all it's options like:

- being able to reproject stuff

- being able to transform / remove /add attributes

- add filters (spatial and non spatial)

- add other outputs, and maybe previews

-etc

I'm not sure if this will work out in a dialog format like this, and I'm not sure if all this should be part of QGIS. To be able to create something like the bottom
(some buttons to save as this or that), also needs one or more extra dialogs.

So do not get me wrong, it is a great idea: a gui for ogr2ogr ( like FME is ;-) ), but I'm wondering if we should stitch this all into QGIS. It would be nice to
base it on QGIS-core, but make it modular or so?

Good idea to pull discussion to this place.

#4 - 2014-06-04 04:59 AM - Nathan Woodrow
Richard Duivenvoorde wrote:
I think it is a good plan to streamline the 'saveas' functions more to work for other data types.
But isn't this the beginning of ETL tool like FME? With all it's options like:
The toolbox is more ETL then this, this is just making the Save As dialog better and the targets then is just to remove the need to change settings all the
time.

- being able to reproject stuff

Save as already does this.

| - being able to transform / remove /add attributes

Not in scope for this tool. This should be done using a query on the layer, then exporting the query. One tool for one job.

- add filters (spatial and non spatial)

2025-04-26 3/5



Not in scope for this tool. Use a query, export that.

- add other outputs, and maybe previews

All formats would be supported, there is no others. What previews?

- etc

I'm not sure if this will work out in a dialog format like this, and I'm not sure if all this should be part of QGIS. To be able to create something like the

bottom (some buttons to save as this or that), also needs one or more extra dialogs.

Not at all, there is a Save as Target which just takes the config you have set and saves it. No extra stuff needed.

So do not get me wrong, it is a great idea: a gui for ogr2ogr ( like FME is ;-) ), but I'm wondering if we should stitch this all into QGIS. It would be nice

to base it on QGIS-core, but make it modular or so?

It would be a widget in gui and core stuff in core so it can be reused. | would also plan to make a standalone (python app) that does it outside of QGIS.

Good idea to pull discussion to this place.

#5 - 2014-06-04 10:06 AM - Anita Graser

+1 for getting rid of as many modal dialogs as possible.

My other first reaction was: There's a layer list right to a layer list ...

I don't share Richard's concerns about this getting too ETL tool like. It's an improved "Save as" interface.

One question concerning exporting multiple layers at once: How would the workflow be to export multiple layers to e.g. Shapefile? How are the filenames

picked/generated?

#6 - 2014-06-04 07:26 PM - Nathan Woodrow

Anita Graser wrote:

+1 for getting rid of as many modal dialogs as possible.

My other first reaction was: There's a layer list right to a layer list ...

Yes that is a good point, both might not be needed, it would just be a matter of playing with it.

One question concerning exporting multiple layers at once: How would the workflow be to export multiple layers to e.g. Shapefile? How are the

filenames picked/generated?
The plan was to have some of kind of config options something like: ask, match, or something like that. | haven't fleshed it that out yet, but it should be
flexible.

#7 - 2014-06-05 11:03 PM - Vincent chourmo

If this is the only way to save a file, it is an horrible idea. QGIS must use the standard / platform way to save files. It gives a lot of benefits for the platform.
For instance, on a mac, you have folders, per file tagging and virtual folders, access to several cloud based storage (on the next version)... More
importantly, it makes QGIS a good platform citizen, improves consistency and helps discovery for the end user. Ways exists to implement parameters in

the save dialog, or with a previous/after dialog.

It may be a good idea to have a batch conversion interface, in QGIS Browser for instance.

#8 - 2014-06-05 11:34 PM - Nathan Woodrow

Vincent chourmo wrote:

If this is the only way to save a file, it is an horrible idea. QGIS must use the standard / platform way to save files. It gives a lot of benefits for the
platform. For instance, on a mac, you have folders, per file tagging and virtual folders, access to several cloud based storage (on the next version)...
More importantly, it makes QGIS a good platform citizen, improves consistency and helps discovery for the end user. Ways exists to implement

parameters in the save dialog, or with a previous/after dialog.

It may be a good idea to have a batch conversion interface, in QGIS Browser for instance.

Just to be clear this doesn't change how the old Save As.. works. You can still pick pick a folder and Save As.. like normal. | have only just seen that my

mockup is missing the folder input, which of course only makes sense for file based formats. | will update the screen shot.

#9 - 2017-05-01 12:47 AM - Giovanni Manghi
- Easy fix? set to No

Files
